Path: text.usenetserver.com!out04b.usenetserver.com!news.usenetserver.com!in02.usenetserver.com!news.usenetserver.com!postnews.google.com!s15g2000prm.googlegroups.com!not-for-mail
From:  David BL <davidbl@iinet.net.au>
Newsgroups: comp.databases.theory
Subject: Re: RM and abstract syntax trees
Date: Mon, 12 Nov 2007 19:10:34 -0800
Organization: http://groups.google.com
Lines: 74
Message-ID: <1194923434.409670.11930@s15g2000prm.googlegroups.com>
References: <1193713604.283167.146850@e34g2000pro.googlegroups.com>
   <aa2dnV0VyZodZLvanZ2dnUVZ8qqlnZ2d@pipex.net>
   <1193743772.498246.198100@e34g2000pro.googlegroups.com>
   <a6KVi.160778$1y4.93722@pd7urf2no>
   <1193790888.643295.55060@e34g2000pro.googlegroups.com>
   <lyQVi.162446$th2.72407@pd7urf3no>
   <1193796029.446713.108270@k35g2000prh.googlegroups.com>
   <LIYVi.3472$p%.201@trndny03>
   <1194634928.585870.33340@o3g2000hsb.googlegroups.com>
   <1194640147.913250.292390@k35g2000prh.googlegroups.com>
   <1194654877.790046.216350@s15g2000prm.googlegroups.com>
   <1194664476.525851.47380@y27g2000pre.googlegroups.com>
NNTP-Posting-Host: 203.59.28.147
Mime-Version: 1.0
Content-Type: text/plain; charset="us-ascii"
X-Trace: posting.google.com 1194923435 31285 127.0.0.1 (13 Nov 2007 03:10:35 GMT)
X-Complaints-To: groups-abuse@google.com
NNTP-Posting-Date: Tue, 13 Nov 2007 03:10:35 +0000 (UTC)
In-Reply-To: <1194664476.525851.47380@y27g2000pre.googlegroups.com>
User-Agent: G2/1.0
X-HTTP-UserAgent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.2; WOW64; SV1; .NET CLR 2.0.50727),gzip(gfe),gzip(gfe)
Complaints-To: groups-abuse@google.com
Injection-Info: s15g2000prm.googlegroups.com; posting-host=203.59.28.147;
   posting-account=ps2QrAMAAAA6_jCuRt2JEIpn5Otqf_w0
Xref: usenetserver.com comp.databases.theory:167311
X-Received-Date: Mon, 12 Nov 2007 22:10:35 EST (text.usenetserver.com)

On Nov 10, 12:14 pm, Marshall <marshall.spi...@gmail.com> wrote:
> On Nov 9, 4:34 pm, David BL <davi...@iinet.net.au> wrote:
> > On Nov 10, 5:29 am, Marshall <marshall.spi...@gmail.com> wrote:
>
> > > The issue is that pointers need referencing and dereferencing
> > > operators which are not part of the relational algebra. Pointers
> > > have an associated address space. Pointers are volatile and
> > > anchored to a specific run of a specific program on a specific
> > > machine, whereas relational ids are durable. Pointers are
> > > physical and ids are logical.
>
> > You appear to draw conclusions from your assumption that the RDB is
> > durable whereas the machine process is not.  What happens if you
> > delete the RDB?  To what extent is a bank account identifier
> > meaningful without the associated DB?
>
> > What about pointers between objects in a POS (Persistent Object
> > Store)?  Are you saying they aren't really pointers because the
> > address space is durable?
>
> > I would rather say that the pointer concept is orthogonal to volatile
> > versus durable concerns.
>
> You misunderstand me.
>
> I'll take you up on the object graph example. Suppose you
> have an object graph on one machine, with edges encoded
> as pointers. Suppose you serialize that object graph, send it
> to another machine and deserialize it there. The pointer values
> will all necessarily be different.

Not necessarily.  Under restricted circumstances it is quite
reasonable to send objects between two compatible Von Neumann machines
on the assumption that they be written to the same memory locations.
Core dumps do this sort of thing.

> Suppose you take the same graph as a pair of relations for
> nodes and edges, with node ids. Now consider the
> serialize/deserialize scenario again. The key values
> are all the same.

Not necessarily.  It is possible (and would indeed sometimes be
important) to reallocate node ids when sending a graph from one RDB to
another, to avoid clashes.

> The point is, pointer values are transient, ephemeral,
> temporary, living only as long as the *process* they
> are embedded in. Whereas the key values in the
> relations are a first class part of the data, and so
> live as long as the data does.

The important thing is that pointer values are only meaningful in the
address of the process, and node identifiers are only meaningful in
the "address space" of the RDB.  You argue that pointer values are
transient, ephemeral, temporary,  but that is only because processes
tend to be transient, ephemeral, temporary.

What would you say if those relations are declared on the stack frame
within the implementation of a function?   Now those relations seem
rather transient, ephemeral and temporary.

> The point is not the lifespan of the data; the point
> is the lifespan of the pointer values relative to the
> lifespan of the data. With keys, it's the same; with
> pointers, it's not.

What does "lifespan of the data" mean?   Are you saying data exists
independently of the database?   Isn't that merely a question for
philosophers to argue over?

> And this was only one of a number of differences
> I cited. The two aren't the same.


